Index: bsp-howto/conf.py
===================================================================
--- bsp-howto/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ bsp-howto/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,8 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS BSP and Device Driver Development Guide"
 
-latex_documents = [
-	('index', 'bsp-howto.tex', u'RTEMS BSP and Device Driver Development Guide', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'bsp-howto.tex',
+                    u'RTEMS BSP and Device Driver Development Guide',
+                    u'RTEMS Documentation Project', 'manual')]
Index: c-user/conf.py
===================================================================
--- c-user/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ c-user/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS C User Manual"
 
-latex_documents = [
-	('index', 'c-user.tex', u'RTEMS C User Documentation', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'c-user.tex',
+                    u'RTEMS C User Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: common/conf.py
===================================================================
--- common/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ common/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -7,5 +7,5 @@
 def build_date():
     now = datetime.date.today()
-    m = now.strftime('%b')
+    m = now.strftime('%B')
     y = now.strftime('%Y')
     if now.day % 10 == 1:
@@ -52,8 +52,8 @@
 #
 # The short X.Y version.
-version = '@VERSION@'
+#version = '@VERSION@'
 
 # The full version, including alpha/beta/rc tags.
-release = '@RELEASE@'
+#release = '@RELEASE@'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
Index: common/html-coverpage/static/rtems/js/catalogue.js
===================================================================
--- common/html-coverpage/static/rtems/js/catalogue.js	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ common/html-coverpage/static/rtems/js/catalogue.js	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -57,10 +57,10 @@
 	    table += empty;
 	if (pdf)
-	    table += '<td><a href="' + '/' + pdf + '">' +
+	    table += '<td><a href="' + pdf + '">' +
  	    '<img src="' + pdfIcon + '" width="20" height="20"></a></td>\n';
 	else
 	    table += empty;
 	if (singlehtml)
-	    table += '<td><a href="' + '/' + singlehtml + '">' +
+	    table += '<td><a href="' + singlehtml + '">' +
 	    '<img src="' + htmlIcon + '" width="20" height="20"></a></td>\n';
 	else
Index: common/waf.py
===================================================================
--- common/waf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ common/waf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -5,4 +5,20 @@
 
 sphinx_min_version = (1, 3)
+
+def build_date():
+    import datetime
+    now = datetime.date.today()
+    m = now.strftime('%B')
+    y = now.strftime('%Y')
+    if now.day % 10 == 1:
+        s = 'st'
+    elif now.day % 10 == 2:
+        s = 'nd'
+    elif now.day == 3:
+        s = 'rd'
+    else:
+        s = 'th'
+    d = '%2d%s' % (now.day, s)
+    return '%s %s %s' % (d, m, y)
 
 def cmd_spell(ctx):
@@ -88,4 +104,7 @@
     doctrees = os.path.join(os.path.dirname(output_dir), 'doctrees', buildtype)
     return build_dir, output_node, output_dir, doctrees
+
+def version_cmdline(ctx):
+    return "-Drelease='%s' -Dversion='%s'" % (ctx.env.VERSION, ctx.env.VERSION)
 
 def pdf_resources(ctx, buildtype):
@@ -136,4 +155,6 @@
 
 def cmd_configure(ctx):
+    ctx.msg('Checking version', ctx.env.VERSION)
+
     ctx.find_program("sphinx-build", var="BIN_SPHINX_BUILD", mandatory = True)
     ctx.find_program("aspell", var = "BIN_ASPELL", mandatory = False)
@@ -181,6 +202,6 @@
     build_dir, output_node, output_dir, doctrees = build_dir_setup(ctx, buildtype)
     pdf_resources(ctx, buildtype)
-    rule = "${BIN_SPHINX_BUILD} %s -b %s -c %s -d %s %s %s" % \
-           (sphinx_verbose(ctx), buildtype, conf_dir,
+    rule = "${BIN_SPHINX_BUILD} %s -b %s -c %s %s -d %s %s %s" % \
+           (sphinx_verbose(ctx), buildtype, conf_dir, version_cmdline(ctx),
             doctrees, source_dir, output_dir)
     ctx(
@@ -233,6 +254,6 @@
     build_dir, output_node, output_dir, doctrees = build_dir_setup(ctx, buildtype)
     html_resources(ctx, buildtype)
-    rule = "${BIN_SPHINX_BUILD} %s -b %s -c %s -d %s %s %s" % \
-           (sphinx_verbose(ctx), buildtype, conf_dir,
+    rule = "${BIN_SPHINX_BUILD} %s -b %s -c %s %s -d %s %s %s" % \
+           (sphinx_verbose(ctx), buildtype, conf_dir, version_cmdline(ctx),
             doctrees, source_dir, output_dir)
     ctx(
@@ -255,6 +276,6 @@
     build_dir, output_node, output_dir, doctrees = build_dir_setup(ctx, buildtype)
     html_resources(ctx, buildtype)
-    rule = "${BIN_SPHINX_BUILD} %s -b %s -c %s -d %s %s %s" % \
-           (sphinx_verbose(ctx), buildtype, conf_dir,
+    rule = "${BIN_SPHINX_BUILD} %s -b %s -c %s %s -d %s %s %s" % \
+           (sphinx_verbose(ctx), buildtype, conf_dir, version_cmdline(ctx),
             doctrees, source_dir, output_dir)
     ctx(
@@ -314,5 +335,5 @@
     cmd_configure(ctx)
 
-def xml_catalogue(ctx, building, title):
+def xml_catalogue(ctx, building):
     #
     # The following is a hack to find the top_dir because the task does
@@ -339,6 +360,6 @@
         catalogue[doc] = {
             'title': bconf.project,
-            'version':  bconf.version,
-            'release': bconf.release,
+            'version': str(ctx.env.VERSION),
+            'release': str(ctx.env.VERSION),
             'pdf': bconf.latex_documents[0][1].replace('.tex', '.pdf'),
             'html': '%s/index.html' % (doc),
@@ -351,9 +372,9 @@
 
     root = cat.createElement('rtems-docs')
-    root.setAttribute('date', 'today')
+    root.setAttribute('date', build_date())
     cat.appendChild(root)
 
     heading = cat.createElement('catalogue')
-    text = cat.createTextNode(title)
+    text = cat.createTextNode(str(ctx.env.VERSION))
     heading.appendChild(text)
     root.appendChild(heading)
Index: cpu-supplement/conf.py
===================================================================
--- cpu-supplement/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ cpu-supplement/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '1.0'
-release = '4.11.0'
-
 project = "RTEMS CPU Supplement Documentation"
 
-latex_documents = [
-	('index', 'cpu-supplement.tex', u'RTEMS CPU Supplement Documentation', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'cpu-supplement.tex',
+                    u'RTEMS CPU Supplement Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: develenv/conf.py
===================================================================
--- develenv/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ develenv/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,8 +4,7 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
-latex_documents = [
-	('index', 'develenv.tex', u'RTEMS Development Environment Documentation', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'develenv.tex',
+                    u'RTEMS Development Environment Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: eclipse/conf.py
===================================================================
--- eclipse/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ eclipse/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS Eclipse Manual"
 
-latex_documents = [
-	('index', 'eclipse.tex', u'RTEMS Eclipse Manual', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'eclipse.tex',
+                    u'RTEMS Eclipse Manual',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: filesystem/conf.py
===================================================================
--- filesystem/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ filesystem/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS Filesystem Design Guide"
 
-latex_documents = [
-	('index', 'filesystem.tex', u'RTEMS Filesystem Design Guide', u'RTEMS Filesystem Design Guide', 'manual'),
-]
+latex_documents = [('index',
+                    'filesystem.tex',
+                    u'RTEMS Filesystem Design Guide',
+                    u'RTEMS Filesystem Design Guide',
+                    'manual')]
Index: networking/conf.py
===================================================================
--- networking/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ networking/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS Networking User Manual"
 
-latex_documents = [
-	('index', 'networking.tex', u'RTEMS Networking User Documentation', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'networking.tex',
+                    u'RTEMS Networking User Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: porting/conf.py
===================================================================
--- porting/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ porting/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,9 +4,7 @@
 from conf import *
 
-version = '1.0'
-release = '5.0'
-
-latex_documents = [
-	('index', 'porting.tex', u'RTEMS Porting Documentation', u'RTEMS Documentation Project', 'manual'),
-]
-
+latex_documents = [('index',
+                    'porting.tex',
+                    u'RTEMS Porting Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: posix-users/conf.py
===================================================================
--- posix-users/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ posix-users/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS POSIX User Manual"
 
-latex_documents = [
-	('index', 'posix-users.tex', u'RTEMS POSIX API User\'s Guide', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'posix-users.tex',
+                    u'RTEMS POSIX API User\'s Guide',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: posix1003-1/conf.py
===================================================================
--- posix1003-1/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ posix1003-1/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,8 +4,7 @@
 from conf import *
 
-version = '1.0'
-release = '5.0'
-
-latex_documents = [
-	('index', 'posix1003-1.tex', u'RTEMS POSIX 1003_1 Documentation', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'posix1003-1.tex',
+                    u'RTEMS POSIX 1003_1 Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: rsb/conf.py
===================================================================
--- rsb/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ rsb/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS Source Builder Manual"
 
-latex_documents = [
-	('index', 'rsb.tex', u'RTEMS Source Builder', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'rsb.tex',
+                    u'RTEMS Source Builder',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: rtemsconfig/conf.py
===================================================================
--- rtemsconfig/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ rtemsconfig/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,9 +4,7 @@
 from conf import *
 
-version = '1.0'
-release = '5.0'
-
-latex_documents = [
-	('index', 'rtemsconfig.tex', u'RTEMS RTEMS Config Documentation', u'RTEMS Documentation Project', 'manual'),
-]
-
+latex_documents = [('index',
+                    'rtemsconfig.tex',
+                    u'RTEMS RTEMS Config Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: shell/conf.py
===================================================================
--- shell/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ shell/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -4,10 +4,9 @@
 from conf import *
 
-version = '4.11.0'
-release = '4.11.0'
-
 project = "RTEMS Shell Manual"
 
-latex_documents = [
-	('index', 'shell.tex', u'RTEMS Shell Documentation', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'shell.tex',
+                    u'RTEMS Shell Documentation',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: user/conf.py
===================================================================
--- user/conf.py	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ user/conf.py	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -3,7 +3,4 @@
 
 from conf import *
-
-version = '4.11.0'
-release = '4.11.0'
 
 project = "RTEMS User Manual"
@@ -40,5 +37,7 @@
                     'waf/index.rst']
 
-latex_documents = [
-	('index', 'user.tex', u'RTEMS User Manual', u'RTEMS Documentation Project', 'manual'),
-]
+latex_documents = [('index',
+                    'user.tex',
+                    u'RTEMS User Manual',
+                    u'RTEMS Documentation Project',
+                    'manual')]
Index: wscript
===================================================================
--- wscript	(revision c2c29d8831cba10df7ddaa2cc7406461eec9dc96)
+++ wscript	(revision 81276042d235328168d75c6a736a9882244e8286)
@@ -10,5 +10,5 @@
 import waf as docs_waf
 
-version = '4.11 (4.11.2)'
+version = '4.11 (branch)'
 
 build_all = ['user',
@@ -30,4 +30,5 @@
 
 def configure(conf):
+    conf.env.VERSION = version
     for b in building:
         conf.recurse(b)
@@ -35,5 +36,5 @@
 
 def catalogue(ctx):
-    docs_waf.xml_catalogue(ctx, building, version)
+    docs_waf.xml_catalogue(ctx, building)
 
 def coverpage_js(ctx):