Index: c/src/lib/libbsp/i386/pc386/console/conscfg.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/console/conscfg.c	(revision 6db5ea03c359c6230fdc53e0b035f25d9e0cf1f3)
+++ c/src/lib/libbsp/i386/pc386/console/conscfg.c	(revision 94300521d908cc8d1c1e7a5aba96ab9434eee57b)
@@ -1,10 +1,12 @@
-/*
- *  This file contains the libchip configuration information
- *  to instantiate the libchip driver for the VGA console
- *  and serial ports on a PC.
+/**
+ * @file
+ *
+ * This file contains the libchip configuration information
+ * to instantiate the libchip driver for the VGA console
+ * and serial ports on a PC.
  */
 
 /*
- *  COPYRIGHT (c) 1989-2014.
+ *  COPYRIGHT (c) 1989-2014, 2016.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -13,6 +15,4 @@
  *  http://www.rtems.org/license/LICENSE.
  */
-
-#include <unistd.h> /* write */
 
 #include <bsp.h>
@@ -24,5 +24,4 @@
 #include <bsp/irq.h>
 #include <rtems/pci.h>
-#include <bsp/rtd316.h>
 
 #if BSP_ENABLE_VGA
@@ -50,5 +49,5 @@
   {
     register uint8_t val;
-  
+
     inport_byte( (addr + i),val );
     return val;
@@ -59,4 +58,6 @@
     outport_byte( (addr + i),val );
   }
+
+  extern bool pc386_com1_com4_enabled(int);
 #endif
 
@@ -69,5 +70,5 @@
   {
     "/dev/vgacons",                        /* sDeviceName */
-    -1,                                     /* deviceType */
+    -1,                                    /* deviceType */
     &edison_fns,                           /* pDeviceFns */
     NULL,                                  /* deviceProbe */
@@ -113,5 +114,5 @@
     SERIAL_NS16550,                        /* deviceType */
     COM_CONSOLE_FUNCTIONS,                 /* pDeviceFns */
-    NULL,                                  /* deviceProbe, assume it is there */
+    pc386_com1_com4_enabled,               /* deviceProbe */
     NULL,                                  /* pDeviceFlow */
     16,                                    /* ulMargin */
@@ -132,5 +133,5 @@
     SERIAL_NS16550,                        /* deviceType */
     COM_CONSOLE_FUNCTIONS,                 /* pDeviceFns */
-    NULL,                                  /* deviceProbe, assume it is there */
+    pc386_com1_com4_enabled,               /* deviceProbe */
     NULL,                                  /* pDeviceFlow */
     16,                                    /* ulMargin */
@@ -152,5 +153,5 @@
     SERIAL_NS16550,                        /* deviceType */
     COM_CONSOLE_FUNCTIONS,                 /* pDeviceFns */
-    NULL,                                  /* deviceProbe, assume it is there */
+    pc386_com1_com4_enabled,               /* deviceProbe */
     NULL,                                  /* pDeviceFlow */
     16,                                    /* ulMargin */
@@ -172,5 +173,5 @@
     SERIAL_NS16550,                        /* deviceType */
     COM_CONSOLE_FUNCTIONS,                 /* pDeviceFns */
-    NULL,                                  /* deviceProbe, assume it is there */
+    pc386_com1_com4_enabled,               /* deviceProbe */
     NULL,                                  /* pDeviceFlow */
     16,                                    /* ulMargin */
Index: c/src/lib/libbsp/i386/pc386/console/console_select.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/console/console_select.c	(revision 6db5ea03c359c6230fdc53e0b035f25d9e0cf1f3)
+++ c/src/lib/libbsp/i386/pc386/console/console_select.c	(revision 94300521d908cc8d1c1e7a5aba96ab9434eee57b)
@@ -31,4 +31,20 @@
   #include <crt.h>
 #endif
+
+/*
+ * Forward prototype
+ */
+extern bool pc386_com1_com4_enabled(int);
+
+/*
+ * This method is used to determine if COM1-COM4 are enabled based upon
+ * boot command line arguments.
+ */
+static bool are_com1_com4_enabled;
+
+bool pc386_com1_com4_enabled(int minor)
+{
+  return are_com1_com4_enabled;
+}
 
 /*
@@ -102,4 +118,20 @@
 
   return false;
+}
+
+static void parse_com1_com4_enable(void)
+{
+  static const char *opt;
+
+  /*
+   * Check the command line to see if com1-com4 are disabled.
+   */
+  opt = bsp_cmdline_arg("--disable-com1-com4");
+  if ( opt ) {
+    printk( "Disable COM1-COM4 per boot argument\n" );
+    are_com1_com4_enabled = false;
+  } else {
+    are_com1_com4_enabled = true;
+  }
 }
 
@@ -199,4 +231,9 @@
 
   /*
+   * Determine if COM1-COM4 were disabled.
+   */
+  parse_com1_com4_enable();
+
+  /*
    * Assume that if only --console is specified, that printk() should
    * follow that selection by default.