Index: libbsd.py
===================================================================
--- libbsd.py	(revision 97c5f8e8de8bfc039a48f504b71e2905b224b418)
+++ libbsd.py	(revision 104304864887f0e3765bb28333dc7b9bd991aa4f)
@@ -3731,42 +3731,22 @@
         [
             'contrib/tcpdump/addrtoname.h',
+            'contrib/tcpdump/addrtostr.h',
             'contrib/tcpdump/af.h',
             'contrib/tcpdump/ah.h',
-            'contrib/tcpdump/aodv.h',
             'contrib/tcpdump/appletalk.h',
-            'contrib/tcpdump/arcnet.h',
+            'contrib/tcpdump/ascii_strcasecmp.h',
             'contrib/tcpdump/atm.h',
-            'contrib/tcpdump/bgp.h',
-            'contrib/tcpdump/bootp.h',
             'contrib/tcpdump/chdlc.h',
             'contrib/tcpdump/cpack.h',
-            'contrib/tcpdump/dccp.h',
-            'contrib/tcpdump/decnet.h',
-            'contrib/tcpdump/decode_prefix.h',
-            'contrib/tcpdump/enc.h',
-            'contrib/tcpdump/esp.h',
             'contrib/tcpdump/ether.h',
             'contrib/tcpdump/ethertype.h',
             'contrib/tcpdump/extract.h',
-            'contrib/tcpdump/fddi.h',
-            'contrib/tcpdump/forces.h',
             'contrib/tcpdump/gmpls.h',
             'contrib/tcpdump/gmt2local.h',
-            'contrib/tcpdump/icmp6.h',
-            'contrib/tcpdump/ieee802_11.h',
-            'contrib/tcpdump/ieee802_11_radio.h',
-            'contrib/tcpdump/igrp.h',
             'contrib/tcpdump/interface.h',
+            'contrib/tcpdump/ip6.h',
             'contrib/tcpdump/ip.h',
-            'contrib/tcpdump/ip6.h',
-            'contrib/tcpdump/ipfc.h',
-            'contrib/tcpdump/ipnet.h',
             'contrib/tcpdump/ipproto.h',
-            'contrib/tcpdump/ipsec_doi.h',
-            'contrib/tcpdump/ipx.h',
-            'contrib/tcpdump/isakmp.h',
-            'contrib/tcpdump/l2tp.h',
             'contrib/tcpdump/l2vpn.h',
-            'contrib/tcpdump/lane.h',
             'contrib/tcpdump/llc.h',
             'contrib/tcpdump/machdep.h',
@@ -3774,36 +3754,25 @@
             'contrib/tcpdump/mpls.h',
             'contrib/tcpdump/nameser.h',
-            'contrib/tcpdump/netbios.h',
             'contrib/tcpdump/netdissect.h',
+            'contrib/tcpdump/netdissect-stdinc.h',
             'contrib/tcpdump/nfs.h',
             'contrib/tcpdump/nfsfh.h',
             'contrib/tcpdump/nlpid.h',
-            'contrib/tcpdump/ntp.h',
-            'contrib/tcpdump/oakley.h',
+            'contrib/tcpdump/openflow.h',
             'contrib/tcpdump/ospf.h',
-            'contrib/tcpdump/ospf6.h',
             'contrib/tcpdump/oui.h',
             'contrib/tcpdump/pcap-missing.h',
-            'contrib/tcpdump/pmap_prot.h',
-            'contrib/tcpdump/ppi.h',
             'contrib/tcpdump/ppp.h',
-            'contrib/tcpdump/route6d.h',
+            'contrib/tcpdump/print.h',
             'contrib/tcpdump/rpc_auth.h',
             'contrib/tcpdump/rpc_msg.h',
-            'contrib/tcpdump/rx.h',
-            'contrib/tcpdump/sctpConstants.h',
-            'contrib/tcpdump/sctpHeader.h',
+            'contrib/tcpdump/rpl.h',
             'contrib/tcpdump/setsignal.h',
             'contrib/tcpdump/signature.h',
             'contrib/tcpdump/slcompress.h',
-            'contrib/tcpdump/slip.h',
-            'contrib/tcpdump/sll.h',
             'contrib/tcpdump/smb.h',
+            'contrib/tcpdump/strtoaddr.h',
             'contrib/tcpdump/tcp.h',
-            'contrib/tcpdump/tcpdump-stdinc.h',
-            'contrib/tcpdump/telnet.h',
-            'contrib/tcpdump/tftp.h',
-            'contrib/tcpdump/timed.h',
-            'contrib/tcpdump/token.h',
+            'contrib/tcpdump/timeval-operations.h',
             'contrib/tcpdump/udp.h',
             'usr.sbin/tcpdump/tcpdump/config.h',
@@ -3813,5 +3782,7 @@
         [
             'contrib/tcpdump/addrtoname.c',
+            'contrib/tcpdump/addrtostr.c',
             'contrib/tcpdump/af.c',
+            'contrib/tcpdump/ascii_strcasecmp.c',
             'contrib/tcpdump/bpf_dump.c',
             'contrib/tcpdump/checksum.c',
@@ -3821,7 +3792,8 @@
             'contrib/tcpdump/in_cksum.c',
             'contrib/tcpdump/ipproto.c',
+            'contrib/tcpdump/l2vpn.c',
             'contrib/tcpdump/machdep.c',
+            'contrib/tcpdump/netdissect.c',
             'contrib/tcpdump/nlpid.c',
-            'contrib/tcpdump/l2vpn.c',
             'contrib/tcpdump/oui.c',
             'contrib/tcpdump/parsenfsfh.c',
@@ -3829,5 +3801,7 @@
             'contrib/tcpdump/print-802_15_4.c',
             'contrib/tcpdump/print-ah.c',
+            'contrib/tcpdump/print-ahcp.c',
             'contrib/tcpdump/print-aodv.c',
+            'contrib/tcpdump/print-aoe.c',
             'contrib/tcpdump/print-ap1394.c',
             'contrib/tcpdump/print-arcnet.c',
@@ -3842,4 +3816,6 @@
             'contrib/tcpdump/print-bootp.c',
             'contrib/tcpdump/print-bt.c',
+            'contrib/tcpdump/print.c',
+            'contrib/tcpdump/print-calm-fast.c',
             'contrib/tcpdump/print-carp.c',
             'contrib/tcpdump/print-cdp.c',
@@ -3862,15 +3838,20 @@
             'contrib/tcpdump/print-fddi.c',
             'contrib/tcpdump/print-forces.c',
+            'contrib/tcpdump/print-frag6.c',
             'contrib/tcpdump/print-fr.c',
-            'contrib/tcpdump/print-frag6.c',
+            'contrib/tcpdump/print-ftp.c',
+            'contrib/tcpdump/print-geneve.c',
+            'contrib/tcpdump/print-geonet.c',
             'contrib/tcpdump/print-gre.c',
+            'contrib/tcpdump/print-hncp.c',
             'contrib/tcpdump/print-hsrp.c',
+            'contrib/tcpdump/print-http.c',
+            'contrib/tcpdump/print-icmp6.c',
             'contrib/tcpdump/print-icmp.c',
-            'contrib/tcpdump/print-icmp6.c',
             'contrib/tcpdump/print-igmp.c',
             'contrib/tcpdump/print-igrp.c',
-            'contrib/tcpdump/print-ip.c',
             'contrib/tcpdump/print-ip6.c',
             'contrib/tcpdump/print-ip6opts.c',
+            'contrib/tcpdump/print-ip.c',
             'contrib/tcpdump/print-ipcomp.c',
             'contrib/tcpdump/print-ipfc.c',
@@ -3884,23 +3865,30 @@
             'contrib/tcpdump/print-lane.c',
             'contrib/tcpdump/print-ldp.c',
+            'contrib/tcpdump/print-lisp.c',
             'contrib/tcpdump/print-llc.c',
             'contrib/tcpdump/print-lldp.c',
             'contrib/tcpdump/print-lmp.c',
+            'contrib/tcpdump/print-loopback.c',
             'contrib/tcpdump/print-lspping.c',
             'contrib/tcpdump/print-lwapp.c',
             'contrib/tcpdump/print-lwres.c',
+            'contrib/tcpdump/print-m3ua.c',
+            'contrib/tcpdump/print-medsa.c',
             'contrib/tcpdump/print-mobile.c',
             'contrib/tcpdump/print-mobility.c',
             'contrib/tcpdump/print-mpcp.c',
             'contrib/tcpdump/print-mpls.c',
+            'contrib/tcpdump/print-mptcp.c',
             'contrib/tcpdump/print-msdp.c',
             'contrib/tcpdump/print-msnlb.c',
-            'contrib/tcpdump/print-netbios.c',
             'contrib/tcpdump/print-nfs.c',
+            'contrib/tcpdump/print-nsh.c',
             'contrib/tcpdump/print-ntp.c',
             'contrib/tcpdump/print-null.c',
             'contrib/tcpdump/print-olsr.c',
+            'contrib/tcpdump/print-openflow-1.0.c',
+            'contrib/tcpdump/print-openflow.c',
+            'contrib/tcpdump/print-ospf6.c',
             'contrib/tcpdump/print-ospf.c',
-            'contrib/tcpdump/print-ospf6.c',
             'contrib/tcpdump/print-otv.c',
             'contrib/tcpdump/print-pflog.c',
@@ -3908,4 +3896,5 @@
             'contrib/tcpdump/print-pgm.c',
             'contrib/tcpdump/print-pim.c',
+            'contrib/tcpdump/print-pktap.c',
             'contrib/tcpdump/print-ppi.c',
             'contrib/tcpdump/print-ppp.c',
@@ -3914,4 +3903,5 @@
             'contrib/tcpdump/print-radius.c',
             'contrib/tcpdump/print-raw.c',
+            'contrib/tcpdump/print-resp.c',
             'contrib/tcpdump/print-rip.c',
             'contrib/tcpdump/print-ripng.c',
@@ -3920,4 +3910,5 @@
             'contrib/tcpdump/print-rsvp.c',
             'contrib/tcpdump/print-rt6.c',
+            'contrib/tcpdump/print-rtsp.c',
             'contrib/tcpdump/print-rx.c',
             'contrib/tcpdump/print-sctp.c',
@@ -3928,8 +3919,8 @@
             'contrib/tcpdump/print-slow.c',
             'contrib/tcpdump/print-smb.c',
+            'contrib/tcpdump/print-smtp.c',
             'contrib/tcpdump/print-snmp.c',
             'contrib/tcpdump/print-stp.c',
             'contrib/tcpdump/print-sunatm.c',
-            #'contrib/tcpdump/print-sunrpc.c',
             'contrib/tcpdump/print-symantec.c',
             'contrib/tcpdump/print-syslog.c',
@@ -3948,4 +3939,5 @@
             'contrib/tcpdump/print-vtp.c',
             'contrib/tcpdump/print-vxlan.c',
+            'contrib/tcpdump/print-vxlan-gpe.c',
             'contrib/tcpdump/print-wb.c',
             'contrib/tcpdump/print-zephyr.c',
@@ -3955,5 +3947,5 @@
             'contrib/tcpdump/smbutil.c',
             'contrib/tcpdump/tcpdump.c',
-            'contrib/tcpdump/util.c',
+            'contrib/tcpdump/util-print.c',
         ],
         mm.generator['source'](['-D__FreeBSD__=1',